# 	Copyright (c) 2005-2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from command import command, swrapper
from cxutil import pmask

no_import = True

class classifier (command):
	"""
	A base class for match, accept, reject etc. classes
	"""
	parameters = {
		"src": {
			"type": "ipaddr",
			"description": "Source IP address",
			"mask": pmask.Optional,
		},
		"dst": {
			"type": "ipaddr",
			"description": "Destination IP address",
			"mask": pmask.Optional,
		},
		"sport": {
			"type": "int",
			"description": "Source port",
			"mask": pmask.Optional,
		},
		"dport": {
			"type": "int",
			"description": "Destination port",
			"mask": pmask.Optional,
		},
		"proto": {
			"type": "enum",
			"description": "IP protocol number",
			"range": ("tcp","udp","icmp","all",("type","int")),
			"mask": pmask.Optional,
		},
		"fwmark": {
			"type": "int",
			"description": "Iptables mark",
			"mask": pmask.Optional,
		},
	}

