# 	Copyright (c) 2005-2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from string import Template
from command import command,swrapper
from cxutil import utils,flags
from copy import deepcopy
import types

class ppp (command):
	"""
	Configure PPP interface
	"""
	mask = flags.Begin | flags.Force
	priority = 0x550
	parameters = {
		"$1": {
			"type": "interface",
			"description": "interface number",
			"name": "interface",
			"format": Template('ppp$value'),
			"default": "*",
		}
	}

	default = utils.opts({
			"lcp-echo-interval": "60",
			"ktune": True,
			"connect": "/bin/true",
			"persist": True,
			"nodefaultroute": True,
			"debug": True,
			"maxfail": "0",
			"noauth": True,
			"mtu":  "1280",
	})

	# 8<--------------------------------------------------------------------------------
	def merge_options(self,opts):
		opts.envl.def_opts = deepcopy(self.default)
		if opts.envl.has_key("option"):
			utils.subtract(opts.envl.option, opts.envl.def_opts)
		else:
			opts.envl.option = {}

	def format_options(self,opts):
		result = ""
		for x in (opts.envl.def_opts, opts.envl.option):
			for (i,k) in x.items():
				if type(k) == types.BooleanType:
					result += "%s " % (i)
				else:
					result += "%s %s " % (i,k)
		return result

	def clean(self,opts):
		result = swrapper()
		try:
			f = open("/var/run/ppp-%s.pid" % (opts.envl.pppn),"r")
			pid = f.read().strip()
			f.close()
			result.add_commands("exec",[
				"kill %s" % (pid),
				"sleep 2",
			])
		except:
			pass
		return result

	# 8<--------------------------------------------------------------------------------
