# 	Copyright (c) 2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from command import command, swrapper
from cxutil import utils,flags,cmask

class l7 (command):
	"""
	l7 hidden class
	"""

	mask = flags.Satellite | flags.Hidden

	catch = ["l7"]

	def postUp(self,opts):
		if not opts.call_mask & cmask.Signal:
			return

		dev = opts.envl.signal
		q = opts.envg.l7base.index(dev) + 1

		###
		# check for iptables rules
		###
		result = swrapper()
		result.add_commands("exec",[
			"modprobe ip_conntrack_netlink",
			"iptables -t mangle -D OUTPUT -o %s -j NFQUEUE --queue-num %s" %  (dev,q),
			"iptables -t mangle -I OUTPUT -o %s -j NFQUEUE --queue-num %s" %  (dev,q),
			"iptables -t mangle -D FORWARD -o %s -j NFQUEUE --queue-num %s" % (dev,q),
			"iptables -t mangle -I FORWARD -o %s -j NFQUEUE --queue-num %s" % (dev,q),
		])
		###
		# create protocol set
		###
		ps = ""
		for i in opts.envg.l7[dev]:
			ps += " -P %s:%s" % (i, opts.envg.l7[dev].index(i) + q * 1024)
		###
		# check for running l7 and restart it with new protocol set
		###
		result.add_command("daemon",{
			"action": "check",
			"command": "l7-filter -q %s %s" % (q,ps),
			"id": "l7-filter",
			"condition": ps
		})
		return result
