# 	Copyright (c) 2005-2008 Peter V. Saveliev
#
# 	This file is part of Connexion project.
#
# 	Connexion is free software; you can redistribute it and/or modify
# 	it under the terms of the GNU General Public License as published by
# 	the Free Software Foundation; either version 3 of the License, or
# 	(at your option) any later version.
#
# 	Connexion is distributed in the hope that it will be useful,
# 	but WITHOUT ANY WARRANTY; without even the implied warranty of
# 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# 	GNU General Public License for more details.
#
# 	You should have received a copy of the GNU General Public License
# 	along with Connexion; if not, write to the Free Software
# 	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from command import command, swrapper
from cxutil import flags,pmask

class rpdb (command):
	"""
	Routing policy database
	"""
	mask = flags.Begin

	modules = [
		"rule",
	]
	
	subscribe = [
		"xshell.configure.network.interfaces.*",
	]

	comment = ["routing policy database",]

	def post(self,opts,method):
		result = swrapper()
		
		if opts["envl"].has_key("rule"):
			for i in opts["envl"]["rule"]:
				result.add_commands("exec",("ip rule %s %s" % (method,i),))

		result.add_commands("exec",("ip route flush cache",))
		
		return result

	def postUp(self,opts):
		command.postUp(self,opts)
		return self.post(opts,"add")

	def postDown(self,opts):
		command.postDown(self,opts)
		return self.post(opts,"del")


##	subclasses

	class rule (command):
		"""
		Define routing policy
		"""
		mask = flags.Once
	
		parameters = {
			"$1": {
				"type": "string",
				"description": "Policy description (see ip(8) from iproute2)",
				"name": "rule",
				"mask": pmask.List
			}
		}

